import java.util.List;
import java.util.Random;

public class Customer implements Runnable {

  private final List<Account>  accounts;
  private final Random         r         = new Random();
  private final AccountService s         = new AccountService();
  private final int            id;

  public Customer(List<Account> accounts, int id) {
    this.accounts = accounts;
    this.id       = id;
  }

  public void run() {
    for (int i = 0; i < 100; i++) {
      int transaction = r.nextInt(3);
      switch (transaction) {
        case 0:
          {
            int amount = r.nextInt(1000);
            Account a = accounts.get(r.nextInt(20));
            a.deposit(amount);
            System.out.println("Customer " + id + ": Deposited $" + amount);
          }
          break;
        case 1:
          {
            int amount = r.nextInt(1000);
            Account a = accounts.get(r.nextInt(20));
            a.withdraw(amount);
            System.out.println("Customer " + id + ": Withdrew $" + amount);
          }
          break;
        case 2:
          {
            Account a = accounts.get(r.nextInt(20));
            Account b = accounts.get(r.nextInt(20));
            if (a == b) {
              continue;
            }
            try {
              int amount = r.nextInt(1000);
              s.transfer(a, b, amount);
              System.out.println("Customer " + id + ": Transfered $" + amount);
            } catch (Exception ex) {
              ex.printStackTrace();
            }
          }
          break;
        default:
          break;
      }
    }
  }

}
